float timestep = 1; // in frametimes at 60hz
float gravity = 1000; // more is faster
float radius = 200;
float initv = 1 * sqrt(gravity / radius);
float clocktime = 0;
float simtime = 0;

float cx, cy;
Ball sun, earth;
color sunout = color(255,255,55);
color sunin = sunout;
color earthout = color(0,255,0);
color earthin = color(0,0,255);
//color earthout = earthin;

void setup() {
  size(720,720,P3D);
  cx = width/2;
  cy = height/2;
  sun = new Ball(cx, cy, 0, 0, 20);
  sun.inner = sunin;
  sun.outer = sunout;
  earth = new Ball(cx, cy - radius, initv, 0, 5);
  earth.inner = earthin;
  earth.outer = earthout;
  noStroke();
  background(0);
}

void draw() {
//  background(0);
//  earth.inner = earth.outer = earthout;
//  earth.display();
  clocktime = frameCount;
  float steps = (clocktime - simtime)/timestep;
  for (int i = 0; i < steps; ++i) {
    earth.move();
    simtime += timestep;
//    println("Clocktime: ",clocktime, " Simtime: ", simtime);  
  }
//  earth.inner = earth.outer = earthin;
  earth.display();
  sun.display();
}

class Ball {
  float x, y, vx, vy, oldx, oldy;
  float diameter;
  color inner = 0;
  color outer = 255;
 
  Ball(float xin, float yin, float vxin, float vyin, float din) {
    x = oldx = xin;
    y = oldy = yin;
    vx = vxin;
    vy = vyin;
    diameter = din;
  } 
  
  void display() {
    lights();
    pushMatrix();
    translate(oldx,oldy,0);
    fill(inner);
    sphere(diameter);
//    ellipse(x, y, diameter, diameter);
    popMatrix();
    pushMatrix();
    translate(x,y,0);
    fill(outer);
//    ellipse(x, y, diameter * 0.5, diameter * 0.5);
    sphere(diameter);
    popMatrix();
  }
  
  void move() {
    oldx = x;
    oldy = y;
    x += vx * timestep;
    y += vy * timestep;
    float dx = x - cx;
    float dy = y - cy;
    float r = sqrt(dx * dx + dy * dy);
    float a = gravity/(r * r);
    
    vx -= a * (dx/r) * timestep;
    vy -= a * (dy/r) * timestep;
  }
}
